//This is a blueprint file. Do not change this file!

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <dirent.h>
#include <time.h>
#include <inttypes.h>


#define NUMBEROFROWS ##NUMBEROFROWS
#define NUMBEROFCOLS ##NUMBEROFCOLS
#define OUTERDEGREE ##OUTERDEGREE
#define INNERDEGREE ##INNERDEGREE

#define MAXHASH 536870908

uint64_t zero64 = 0;
uint64_t one64 = 1;
uint64_t prime = 536870909;
const uint64_t COLLISIONMARKER = 536870909;

int get(const int *array, int row, int col) {
  return array[row*NUMBEROFCOLS+col];
}
void set(int *array, int row, int col, int data) {
  array[row*NUMBEROFCOLS+col]=data;
}

void printtableau(const int *tableau, const int *rowlengths) {
  {int row;for (row=0;row<NUMBEROFROWS;row++){
    {int col;for (col=0;col<rowlengths[row];col++){
      printf("%d ",get(tableau,row,col));
    }}
    printf("\n");
  }}
  printf("\n");
}


int temp_SWAPINTABLEAU;
void SWAPINTABLEAU(int *tableau,int row0, int col0, int row1, int col1) {
  temp_SWAPINTABLEAU = tableau[row0*NUMBEROFCOLS+col0];
  tableau[row0*NUMBEROFCOLS+col0] = tableau[row1*NUMBEROFCOLS+col1];
  tableau[row1*NUMBEROFCOLS+col1] = temp_SWAPINTABLEAU;
}



//var -> twistedvar -> blockhash (sum of twistedvar) -> twistedblockhash -> hash (sum of twistedblockhash)

uint64_t cache_twistedvar[NUMBEROFCOLS*NUMBEROFROWS];
uint64_t cache_blockhash[OUTERDEGREE];
uint64_t cache_twistedblockhash[OUTERDEGREE];

const uint64_t varhashes[] = {321017603, 409032069, 179149675, 385763043, 386210053, 178229077, 514005093, 137972357, 108903411, 477157075, 386210057, 108903449, 386210057, 409032079, 321017611};

uint64_t cache_twistedvar2[NUMBEROFCOLS*NUMBEROFROWS];
uint64_t cache_blockhash2[OUTERDEGREE];
uint64_t cache_twistedblockhash2[OUTERDEGREE];



uint64_t computehash_and_initializecaches(int *tableau, const int *BLOCKSTRUCTURE, const int *rowlengths) {//not optimized
  uint64_t hash = 0;
  {int block;for (block=0;block<OUTERDEGREE;block++){
    uint64_t blockhash = 0;
    {int row;for (row=0;row<NUMBEROFROWS;row++){
      {int col;for (col=0;col<rowlengths[row];col++){
        if (get(BLOCKSTRUCTURE,row,col)==block) {
          uint64_t var = varhashes[get(tableau,row,col)];
          uint64_t twistedvar = ##TWISTEDVAR;
          blockhash += twistedvar;
          if (blockhash>=prime) blockhash-=prime;
          cache_twistedvar[row*NUMBEROFCOLS+col] = twistedvar;
        }
      }}
    }}
    cache_blockhash[block] = blockhash;
    //printf("c-blockhash = %" PRIu64 "\n", blockhash);
    ##PREPARETWISTEDBLOCKHASH
    uint64_t twistedblockhash = ##TWISTEDBLOCKHASH;
    cache_twistedblockhash[block] = twistedblockhash;
    hash += twistedblockhash;
    if (hash>=prime) hash-=prime;
  }}
  return hash;
}

uint64_t computehash_and_initializecaches2(int *tableau, const int *BLOCKSTRUCTURE, const int *rowlengths) {//not optimized
  uint64_t hash = 0;
  {int block;for (block=0;block<OUTERDEGREE;block++){
    uint64_t blockhash = 0;
    {int row;for (row=0;row<NUMBEROFROWS;row++){
      {int col;for (col=0;col<rowlengths[row];col++){
        if (get(BLOCKSTRUCTURE,row,col)==block) {
          uint64_t var = varhashes[get(tableau,row,col)];
          uint64_t twistedvar = ##TWISTEDVA2;
          blockhash += twistedvar;
          if (blockhash>=prime) blockhash-=prime;
          cache_twistedvar2[row*NUMBEROFCOLS+col] = twistedvar;
        }
      }}
    }}
    cache_blockhash2[block] = blockhash;
    ##PREPARETWISTEDBLOCKHAS2
    uint64_t twistedblockhash = ##TWISTEDBLOCKHAS2;
    cache_twistedblockhash2[block] = twistedblockhash;
    hash += twistedblockhash;
    if (hash>=prime) hash-=prime;
  }}
  return hash;
}

int main(int argc, char *argv[]) {
  //outer 4, inner 3
  const int rowlengths[NUMBEROFROWS] = {##ROWLENGTHS};
  const int collengths[NUMBEROFCOLS] = {##COLLENGTHS};
  const uint64_t PRODUCTOFCOLUMNLENGTHFACTORIALS = ##PRODUCTOFCOLUMNLENGTHFACTORIALS;
  const int swaplength8row0[40320] = {0-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-
1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,8-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,8-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,7-1};
  const int swaplength8row1[40320] = {0-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-
1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,1-1,8-1,2-1,3-1,4-1,5-1,6-1,7-1,8-1};
  const int swaplength7row0[5040] = {0-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-
1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-
1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-
1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-
1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,6-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,1-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,7-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,6-1,3-1,7-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,6-1,5-1,7-1,6-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,5-1,6-1,2-1,7-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,6-1,4-1,7-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,6-1};
  const int swaplength7row1[5040] = {0-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-
1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-
1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-
1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-
1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,1-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,7-1,4-1,6-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,7-1,2-1,6-1,5-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,6-1,7-1,6-1,6-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,7-1,3-1,6-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,7-1,5-1,6-1,5-1,4-1,3-1,2-1,1-1,7-1,2-1,3-1,4-1,5-1,6-1,7-1};
  const int swaplength6row0[720] = {0-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,6-1,1-1,2-1,3-1,4-1,5-1,4-1,6-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,5-1,2-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1,1-1,6-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,5-1,3-1,6-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,5-1};
  const int swaplength6row1[720] = {0-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,6-1,3-1,5-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,6-1,1-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1,2-1,5-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,6-1,4-1,5-1,4-1,3-1,2-1,1-1,6-1,2-1,3-1,4-1,5-1,6-1};
  const int swaplength5row0[120] = {0-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,3-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,4-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,2-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,2-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,3-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,4-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,2-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1,1-1,5-1,4-1,3-1,2-1,5-1,1-1,2-1,3-1,4-1,3-1,5-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1,4-1,3-1,5-1,4-1,3-1,2-1,2-1,1-1,2-1,3-1,4-1,2-1,5-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,4-1};
  const int swaplength5row1[120] = {0-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,2-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,3-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,3-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,1-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,2-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,3-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,3-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1,2-1,4-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1,5-1,2-1,4-1,3-1,2-1,1-1,2-1,2-1,3-1,4-1,5-1,4-1,4-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,5-1,3-1,4-1,3-1,2-1,1-1,5-1,2-1,3-1,4-1,5-1};
  const int swaplength4row0[24] = {0-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,2-1,4-1,3-1,2-1,4-1,1-1,2-1,3-1,1-1,4-1,3-1,2-1,3-1,1-1,2-1,3-1};
  const int swaplength4row1[24] = {0-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,1-1,3-1,2-1,1-1,3-1,2-1,3-1,4-1,2-1,3-1,2-1,1-1,4-1,2-1,3-1,4-1};
  const int swaplength3row0[6] = {0-1,1-1,2-1,1-1,2-1,1-1};
  const int swaplength3row1[6] = {0-1,2-1,3-1,2-1,3-1,2-1};
  const int swaplength2row0[2] = {0-1,1-1};
  const int swaplength2row1[2] = {0-1,2-1};
  const int swaplength1row0[1] = {0-1};
  const int swaplength1row1[1] = {0-1};

  //initialize everything so that the first summand can be counted:
  const int X = -1;
  int tableau[NUMBEROFCOLS*NUMBEROFROWS] = {
    ##TABLEAU
  };
  
  
  const int BLOCKSTRUCTURE[NUMBEROFCOLS*NUMBEROFROWS] = {
    ##BLOCKSTRUCTURE
  };

//  uint64_t hash = computehash_and_initializecaches(tableau,BLOCKSTRUCTURE,rowlengths);
  uint64_t hash = computehash_and_initializecaches(tableau,BLOCKSTRUCTURE,rowlengths);
  uint64_t hash2 = computehash_and_initializecaches2(tableau,BLOCKSTRUCTURE,rowlengths);

##INTCOLPERMFORWARD0BACKWARD1IS0
  
//  long long int hwv [MAXHASH+1];
  long long int *hwv = (long long int *) malloc((MAXHASH+1ULL) * sizeof(long long int));
  if (hwv==NULL) {
    printf("not enough memory\n");
    {
      FILE * pFile;
      pFile = fopen ("temp.py", "wb");
      fclose (pFile);
    }
    {
      FILE * pFile;
      char buffer[1000] = {0};
      sprintf(buffer,##NOTENOUGHMEMFILENAME
      pFile = fopen (buffer, "wb");
      fclose (pFile);
    }
    exit(0);
  }
  {int i;for (i=0;i<MAXHASH+1;i++){
    hwv[i]=0;
  }}
  
##COLLISIONS
  
  int swappedcol = 0;
  int swappedrow0 = 0;
  int swappedrow1 = 0;
  
  long long int sign = 1;
  {uint64_t i;for (i=0;i<PRODUCTOFCOLUMNLENGTHFACTORIALS;i++){
    //printtableau(tableau,rowlengths);
    if (hwv[hash]!=COLLISIONMARKER) {
      //if (hash2==59637249) printf("Y%d",sign);
      hwv[hash]+=sign;
    } else {
      //if (hash2==59637249) printf("X%d",sign);
      hwv[hash2]+=sign;
    }
    
    sign *= -1;
    //printf("%lld",sign);
##LONGCOMPUTATION

    
    //update the hash based on swappedcol,swappedrow0,swappedrow1:
    {
      int block0 = BLOCKSTRUCTURE[swappedrow0*NUMBEROFCOLS+swappedcol];
      int block1 = BLOCKSTRUCTURE[swappedrow1*NUMBEROFCOLS+swappedcol];
      hash += prime;
      hash -= cache_twistedblockhash[block0];
      if (hash<prime) hash+=prime;
      hash -= cache_twistedblockhash[block1];
      if (hash>=prime) hash-=prime;
      uint64_t blockhash0 = cache_blockhash[block0];
      uint64_t blockhash1 = cache_blockhash[block1];
      blockhash0 += prime;
      blockhash0 -= cache_twistedvar[swappedrow0*NUMBEROFCOLS+swappedcol];
      if (blockhash0>=prime) blockhash0-=prime;
      blockhash1 += prime;
      blockhash1 -= cache_twistedvar[swappedrow1*NUMBEROFCOLS+swappedcol];
      if (blockhash1>=prime) blockhash1-=prime;
      uint64_t newentry0 = varhashes[tableau[swappedrow0*NUMBEROFCOLS+swappedcol]];
      uint64_t newentry1 = varhashes[tableau[swappedrow1*NUMBEROFCOLS+swappedcol]];
      cache_twistedvar[swappedrow0*NUMBEROFCOLS+swappedcol] = ##NEWENTRY0;
      cache_twistedvar[swappedrow1*NUMBEROFCOLS+swappedcol] = ##NEWENTRY1;
      blockhash0 += cache_twistedvar[swappedrow0*NUMBEROFCOLS+swappedcol];
      if (blockhash0>=prime) blockhash0-=prime;
      blockhash1 += cache_twistedvar[swappedrow1*NUMBEROFCOLS+swappedcol];
      if (blockhash1>=prime) blockhash1-=prime;
      cache_blockhash[block0] = blockhash0;
      cache_blockhash[block1] = blockhash1;
      ##PREPAREBLOCKHASH0
      cache_twistedblockhash[block0] = ##BLOCKHASH0;
      ##PREPAREBLOCKHASH1
      cache_twistedblockhash[block1] = ##BLOCKHASH1;
      hash += cache_twistedblockhash[block0];
      if (hash>=prime) hash-=prime;
      hash += cache_twistedblockhash[block1];
      if (hash>=prime) hash-=prime;
    }
    {
      int block0 = BLOCKSTRUCTURE[swappedrow0*NUMBEROFCOLS+swappedcol];
      int block1 = BLOCKSTRUCTURE[swappedrow1*NUMBEROFCOLS+swappedcol];
      hash2 += prime;
      hash2 -= cache_twistedblockhash2[block0];
      if (hash2<prime) hash2+=prime;
      hash2 -= cache_twistedblockhash2[block1];
      if (hash2>=prime) hash2-=prime;
      uint64_t blockhash0 = cache_blockhash2[block0];
      uint64_t blockhash1 = cache_blockhash2[block1];
      blockhash0 += prime;
      blockhash0 -= cache_twistedvar2[swappedrow0*NUMBEROFCOLS+swappedcol];
      if (blockhash0>=prime) blockhash0-=prime;
      blockhash1 += prime;
      blockhash1 -= cache_twistedvar2[swappedrow1*NUMBEROFCOLS+swappedcol];
      if (blockhash1>=prime) blockhash1-=prime;
      uint64_t newentry0 = varhashes[tableau[swappedrow0*NUMBEROFCOLS+swappedcol]];
      uint64_t newentry1 = varhashes[tableau[swappedrow1*NUMBEROFCOLS+swappedcol]];
      cache_twistedvar2[swappedrow0*NUMBEROFCOLS+swappedcol] = ##NEWENTR20;
      cache_twistedvar2[swappedrow1*NUMBEROFCOLS+swappedcol] = ##NEWENTR21;
      blockhash0 += cache_twistedvar2[swappedrow0*NUMBEROFCOLS+swappedcol];
      if (blockhash0>=prime) blockhash0-=prime;
      blockhash1 += cache_twistedvar2[swappedrow1*NUMBEROFCOLS+swappedcol];
      if (blockhash1>=prime) blockhash1-=prime;
      cache_blockhash2[block0] = blockhash0;
      cache_blockhash2[block1] = blockhash1;
      ##PREPAREBLOCKHAS20
      cache_twistedblockhash2[block0] = ##BLOCKHAS20;
      ##PREPAREBLOCKHAS21
      cache_twistedblockhash2[block1] = ##BLOCKHAS21;
      hash2 += cache_twistedblockhash2[block0];
      if (hash2>=prime) hash2-=prime;
      hash2 += cache_twistedblockhash2[block1];
      if (hash2>=prime) hash2-=prime;
    }

    //Sanity checks:
    /*{
      uint64_t guesshash = hash;
      hash = computehash_and_initializecaches(tableau,BLOCKSTRUCTURE,rowlengths);
      if (guesshash != hash) {
        printf("guesshash wrong!\n");
        printf("     hash = %" PRIu64 "\n", hash);
        printf("guesshash = %" PRIu64 "\n", guesshash);
        exit(0);
      }
    }*/
    /*{
      uint64_t guesshash2 = hash2;
      hash2 = computehash_and_initializecaches2(tableau,BLOCKSTRUCTURE,rowlengths);
      if (guesshash2 != hash2) {
        printf("guesshash2 wrong!\n");
        printf("     hash2 = %" PRIu64 "\n", hash2);
        printf("guesshash2 = %" PRIu64 "\n", guesshash2);
        exit(0);
      }
    }*/
  }}
  

  FILE * pFile;
  char buffer[1000] = {0};
  pFile = fopen ("temp.py", "wb");
 
  {int i;for (i=0;i<MAXHASH+1;i++){
    if (hwv[i]!=0) {
      sprintf(buffer,"hwv[%d]=%lld\r\n",i,hwv[i]);
      fwrite (buffer , sizeof(char), strlen(buffer), pFile);
    }
  }}
  
  fclose (pFile);
  
  free(hwv);

  
}
